/* mk_outvec.c
** setup header for outvec_STDOUT.c
** use sysconf() for pulling IOV_MAX on platform
** wcm, 2010.12.01 - 2011.02.04
** ===
*/

#include <stdio.h>
#include <unistd.h>

#define _VEC_STDOUT_MIN  16
#define _VEC_STDOUT_MAX  256

const char  progname[] = "mk_outvec";

int
main(int argc, char * argv[])
{
  long  limit_max = _VEC_STDOUT_MIN;

  (void)argc;
  (void)argv;

#ifdef _SC_IOV_MAX
  limit_max = sysconf(_SC_IOV_MAX);
#else
#include <limits.h>
#ifdef IOV_MAX
  limit_max = IOV_MAX;
#endif
#endif

  printf("/* outvec_STDOUT.h\n"
         "** automatically generated by %s (%s) \n"
         "*/\n\n", progname, __FILE__ );

  printf("#define _VEC_STDOUT_SIZE %d\n\n",
         (limit_max >= _VEC_STDOUT_MAX) ? (int) _VEC_STDOUT_MAX : (int)limit_max);

  printf("/* eof: outvec_STDOUT.h */\n");

  return 0;
} 

/* eof: mk_outvec.c */
